/* Copyright 1988-1992 UserLand Software, Inc.  All Rights Reserved.*/


#define filesinclude


#ifndef appletdefsinclude

	#include "appletdefs.h"
	
#endif


typedef struct tyfileinfo { /*flattens interface for getting file information*/

	bigstring fname;
	
	OSErr errcode;
	
	boolean flfolder, fllocked, flbundle, flbusy, flalias;	
	
	boolean flinvisible; 
	
	OSType filecreator, filetype;
	
	long timecreated, timemodified;
	
	long sizedatafork, sizeresourcefork;
	
	short ixlabel;
	
	Point iconposition; 
	} tyfileinfo;
	

typedef boolean (*sfcallback) (tyfileinfo *);

	
boolean filegetinfo (bigstring, short, tyfileinfo *);

boolean sfdialog (boolean, bigstring, short *, sfcallback, OSType);

boolean fileparsevolname (bigstring, short *);

boolean filedelete (bigstring, short);

void fileclose (short);

long filegetsize (short);

boolean fileseteof (short, long);

boolean fileopenorcreate (bigstring, short, OSType, OSType, short *);

boolean filenew (bigstring, short, OSType, OSType, short *);

boolean fileopen (bigstring, short, short *);

boolean filetruncate (short);

boolean filewrite (short, long, void *);

boolean fileread (short, long, void *);

boolean filewritehandle (short, Handle);

boolean filereadhandle (short, long, Handle *);

boolean filereadwholefile (short, Handle *);

boolean filegetchar (short, byte *);

boolean filefrompath (bigstring, bigstring);

boolean folderfrompath (bigstring, bigstring);

boolean pathtofileinfo (bigstring, bigstring, short *);

boolean directorytopath (long, short, bigstring);

boolean fileinfotopath (bigstring, short, bigstring);

