
/* Copyright 1988-1992 UserLand Software, Inc.  All Rights Reserved.*/


#define undoinclude


#ifndef appletdefsinclude

	#include "appletdefs.h"
	
#endif



typedef struct tystack {

	short topstack;

	short basesize;

	short elemsize;

	byte stack [];
	} tystack, *ptrstack, **hdlstack;


typedef boolean (*undocallback) (Handle, boolean);


typedef struct tyundorecord {
	
	undocallback undoroutine;
	
	Handle hundodata;
	
	boolean flactionstep; /*is this step an action record?*/
	} tyundorecord;


typedef struct tyactionrecord {
	
	long ixaction;
	
	long globaldata;
	
	boolean flaction; /*always true for actionrecords*/
	} tyactionrecord;


typedef struct tyundostack {

	short topundo;
	
	short basesize;
	
	short elemsize;
	
	short ixaction;
	
	long globaldata;
	
	tyundorecord undostep [];
	} tyundostack, *ptrundostack, **hdlundostack;


extern hdlundostack undostack;

extern hdlundostack redostack;


boolean pushundostep (undocallback, Handle);

boolean pushundoaction (short);

boolean popundoaction (void);

boolean undolastaction (boolean);

boolean redolastaction (boolean);

boolean getundoaction (short *);

boolean getredoaction (short *);

void killundo (void);

boolean newundostack (hdlundostack *);

boolean disposeundostack (hdlundostack);

void initundo (void);



